small bug fixes and improvements
[automated-distro-installer] / fai / config / hooks / partition.DEFAULT
index 5d4684c6bf79af7c3bbe6a00dc196885b7505380..aa7440968b8eaca3cde4c43672a69ad5825441c0 100755 (executable)
 #!/bin/bash -x
 
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 # # fai's setup-storage won't do btrfs on luks,
 # # so we do it ourself :)
 
-skiptask partition ||: # for running out of fai
+skiptask partition || ! type skiptask # for running not in fai
 
 #### begin configuration
 
-bootn=1
+rootn=1
 swapn=2
-rootn=3
+bootn=3
 bios_grubn=4
-boot_end=804
-lastn=$bios_grubn
+boot_mib=1500
+
+
+##### end configuration
+
+
+add-part() {
+    local d ret
+    if [[ $# == 1 ]]; then
+        d=$dev
+        part=$1
+    else
+        d=$1
+        part=$2
+    fi
+    if [[ $d == /dev/disk/by-id/* ]]; then
+        ret=$d-part$part
+    else
+        ret=$d$part
+    fi
+    echo $ret
+}
+
+bootdev() { add-part $@ $bootn; }
+rootdev() { add-part $@ $rootn; }
+swapdev() { add-part $@ $swapn; }
+bios_grubdev() { add-part $@ $bios_grubn; }
+
+crypt-dev() { echo /dev/mapper/crypt_dev_${1##*/}; }
+crypt-name() { echo crypt_dev_${1##*/}; }
+root-cryptdev() { crypt-dev $(rootdev $@); }
+swap-cryptdev() { crypt-dev $(swapdev $@); }
+root-cryptname() { crypt-name $(rootdev $@); }
+swap-cryptname() { crypt-name $(swapdev $@); }
+
 
-if ifclass VM; then
-    d=vd
+##### end function defs
+
+if ifclass REPARTITION;then
+    partition=true # force a full wipe
 else
-    d=sd
+    partition=false # change to true to force a full wipe
 fi
 
-letters=()
-if ifclass TWO_DISK; then
-    letters=(a b)
-elif ifclass ONE_DISK; then
-    letters=(a)
-elif ifclass MANY_DISK; then
-    for dev in /dev/${d}?; do letters+=(${dev#/dev/${d}}); done
+lastn=$bios_grubn
+
+
+hdds=()
+ssds=()
+cd /sys/block
+for disk in [sv]d[a-z]; do
+    case $(cat $disk/queue/rotational) in
+        0) ssds+=(/dev/$disk) ;;
+        1) hdds+=(/dev/$disk) ;;
+        *) echo "$0: error: unknown /sys/block/$disk/queue/rotational: \
+$(cat $disk/queue/rotational)"; exit 1 ;;
+    esac
+done
+
+# install all ssds, or if there are none, all hdds
+if (( ${#ssds[@]} > 0 )); then
+    short_devs=( ${ssds[@]} )
 else
-    exit 1
+    short_devs=( ${hdds[@]} )
 fi
-##### end configuration
 
+# check if the partitions exist have the right filesystems
+#blkid="$(blkid -s TYPE)"
+for dev in ${short_devs[@]}; do
+    ! $partition || break
+    y=$(readlink -f $dev)
+    x=($y[0-9])
+    [[ ${#x[@]}  == "${lastn}" ]] || partition=true
+    for (( i=1; i <= lastn; i++ )); do
+        [[ -e ${dev}$i ]] || partition=true
+    done
+    # On one system, blkid is missing some partitions.
+    # maybe we need a flag, like FUZZY_BLKID or something, so we
+    # can check that at least some exist.
+    # for x in "`rootdev`: TYPE=\"crypto_LUKS\"" "`bootdev`: TYPE=\"btrfs\""; do
+    #     echo "$blkid" | grep -Fx "$x" &>/dev/null || partition=true
+    # done
+done
 
-bpart() {
-    dev_n=$1
-    case ${#@} in
-        [1-3]) mkfs.btrfs -f $@ ;;
-        [4-9]*|[1-3]?*) mkfs.btrfs -f -m raid10 -d raid10 $@ ;;
-    esac
-}
+if $partition && ifclass PARTITION_PROMPT; then
+    echo "Press any key except ctrl-c to continue and partition these drives:"
+    echo "  ${short_devs[@]}"
+    read
+fi
+
+devs=()
+shopt -s extglob
+for short_dev in ${short_devs[@]}; do
+    devs+=($(devbyid $short_dev))
+done
 
-devs=(${letters[@]/#//dev/${d}})
-crypt_devs=(${letters[@]/#//dev/mapper/crypt_dev_${d}})
-first_boot_dev=${devs[0]}$bootn
 
-partition=true
 
-# somewhat crude detection of whether to partition
+boot_devs=()
 for dev in ${devs[@]}; do
-    x=($dev[0-9])
-    [[ ${#x[@]}  == ${lastn} ]] || partition=true
-    for (( i=1; i <= $lastn; i++ )); do
-        [[ -e ${dev}$i ]] || partition=true
-    done
-    for part in $dev$rootn $dev$bootn; do
-        # type tells us it's not totally blank
-        blkid | grep "^${part}:.*TYPE=" &>/dev/null || partition=true
-    done
+    if ifclass frodo; then
+        # I ran into a machine where the bios doesn't know about some disks,
+        # so 1st stage of grub also doesn't know about them.
+        # Also, grub does not support mounting degraded btrfs as far as
+        # I can tell with some googling.
+        # From within an arch install env, I could detect them by noting
+        # their partitions were mixed with the next disk in /dev/disk/by-path,
+        # and I have mixed model disks, and I could see the 8 models which showed
+        # up in the bios, and thus see which 2 models were missing.
+        # hdparm -I /dev/sdh will give model info in linux.
+        # However, in fai on jessie, /dev/disk/by-path dir doesn't exist,
+        # and I don't see another way, so I'm hardcoding them.
+        # We still put grub on them and partition them the same, for uniformity
+        # and in case they get moved to a system that can recognize them,
+        # we just exclude them from the boot filesystem.
+        cd /dev/disk/by-id/
+        bad_disk=false
+        for id in ata-TOSHIBA_MD04ACA500_8539K4TQFS9A \
+                      ata-TOSHIBA_MD04ACA500_Y5IFK6IJFS9A; do
+            if [[ $(readlink -f $id) == "$(readlink -f $dev)" ]]; then
+                bad_disk=true
+                break
+            fi
+        done
+        $bad_disk || boot_devs+=(`bootdev`)
+    else
+        boot_devs+=(`bootdev`)
+    fi
 done
 
-#partition=true # for temporarily override
+if [[ ! $DISTRO ]]; then
+    if ifclass STABLE; then
+        DISTRO=debianstable
+    else
+        DISTRO=debiantesting
+    fi
+fi
+
+
+
+case ${#boot_devs[@]} in
+    # need double the space if we are raid 10, and then
+    # might as well give some extra overhead.
+    [4-9]*|[1-3]?*) boot_mib=$((boot_mib * 3)) ;;
+esac
+
+
+bpart() { # btrfs a partition
+    case ${#@} in
+        [1-3]) mkfs.btrfs -f $@ ;;
+        [4-9]*|[1-3]?*) mkfs.btrfs -f -m raid10 -d raid10 $@ ;;
+    esac
+}
+
+first_boot_dev=${boot_devs[0]}
 
 # keyfiles generated like:
 # head -c 2048 /dev/urandom | od | s dd of=/q/root/luks/host-demohost
 luks_dir=${LUKS_DIR:-/var/lib/fai/config/distro-install-common/luks}
+
+if [[ ! -e $luks_dir/host-$HOSTNAME ]]; then
+    echo "$0: error: no key for hostname at $luks_dir/host-$HOSTNAME" >&2
+    exit 1
+fi
+
 if ifclass tp; then
     lukspw=$(cat $luks_dir/traci)
 else
@@ -78,44 +189,71 @@ if ifclass demohost; then
 fi
 
 
-crypt=/dev/mapper/crypt_dev_${d##/dev/}a$rootn
-
+first_root_crypt=$(root-cryptdev ${devs[0]})
 
-if ifclass frodo; then
-    # next upgrade is prolly 16 gigs of memory, across ~8 devices
-    swap_end=$((3500 + boot_end))
-else
-    # 1.5 x based on https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Installation_Guide/sect-disk-partitioning-setup-x86.html#sect-custom-partitioning-x86
-    swap_end=$(( $(grep ^MemTotal: /proc/meminfo| awk '{print $2}') * 3/(${#devs[@]} * 2 ) / 1000 + boot_end ))
-fi
+bios_grubn=4
+# 1.5 x based on https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Installation_Guide/sect-disk-partitioning-setup-x86.html#sect-custom-partitioning-x86
+swap_mib=$(( $(grep ^MemTotal: /proc/meminfo | \
+                   awk '{print $2}') * 3/(${#devs[@]} * 2 ) / 1024 ))
 
 mkdir -p /tmp/fai
+root_devs=()
+for dev in ${devs[@]}; do
+    root_devs+=(`rootdev`)
+done
 shopt -s nullglob
 if $partition; then
     for dev in ${devs[@]}; do
-        for x in $dev[0-9]; do wipefs -a $x; done
+        for x in $dev[0-9]; do
+            count_down=10
+            # wipefs has failed, manual run works, google suggests timing issue
+            while ! wipefs -a $x; do
+                sleep 2
+                count_down=$((count_down - 1))
+                (( count_down > 0 )) || exit 1
+            done
+        done
     done
     for dev in ${devs[@]}; do
+        # parted will round up the disk size. Do -1 so we can have
+        # fully 1MiB unit partitions for easy resizing of the last partition.
+        # Otherwise we would pass in -0 for the end argument for the last partition.
+        #
+        # parted print error output is expected. example:
+        # Error: /dev/vda: unrecognised disk label
+        disk_mib=$(( $(parted -m $dev unit MiB print | \
+                           sed -nr "s#^/dev/[^:]+:([0-9]+).*#\1#p") - 1))
+        root_end=$(( disk_mib - swap_mib - boot_mib /  ${#boot_devs[@]} ))
+        swap_end=$(( root_end + swap_mib))
+
         parted -s $dev mklabel gpt
-        # gpt ubuntu cloud image uses ~4. fai uses 1 MiB. ehh, i'll do 4.
-        # also, using MB instead of MiB causes complains about alignment.
+        # gpt ubuntu cloud image uses ~4. fai uses 1 MiB.
+        # I read something in the parted manual saying cheap flash media
+        # likes to start at 4.
+        # MiB because parted complains about alignment otherwise.
         pcmd="parted -a optimal -s -- $dev"
-        $pcmd mkpart primary "ext3" 4MB ${boot_end}MiB
-        $pcmd mkpart primary "linux-swap" ${boot_end}MiB ${swap_end}MiB
-        $pcmd mkpart primary "" ${swap_end}MiB -0
+        $pcmd mkpart primary "ext3" 4MiB ${root_end}MiB
+        $pcmd mkpart primary "linux-swap" ${root_end}MiB ${swap_end}MiB
+        $pcmd mkpart primary "" ${swap_end}MiB ${disk_mib}MiB
         $pcmd mkpart primary "" 1MiB 4MiB
         $pcmd set $bios_grubn bios_grub on
         $pcmd set $bootn boot on # generally not needed on modern systems
-        # the mkfs failed randomly on a vm, so I threw a sleep in here.
-        sleep .1
-
-
-        luks_dev=$dev$rootn
-        yes YES | cryptsetup luksFormat $luks_dev $luks_dir/host-$HOSTNAME \
+        # the mkfs failed before on a vm, which prompted me to add
+        # sleep .1
+        # then failed on a physical machine
+        # with:
+        # Device /dev/disk/by-id/foo doesn't exist or access denied,
+        # so here we wait.
+        secs=0
+        while [[ ! -e `rootdev` ]] && (( secs < 10 )); do
+            sleep 1
+            secs=$((secs +1))
+        done
+        yes YES | cryptsetup luksFormat `rootdev` $luks_dir/host-$HOSTNAME \
                              -c aes-cbc-essiv:sha256 -s 256 || [[ $? == 141 ]]
         yes "$lukspw" | \
             cryptsetup luksAddKey --key-file $luks_dir/host-$HOSTNAME \
-                       $luks_dev || [[ $? == 141 ]]
+                       `rootdev` || [[ $? == 141 ]]
         # background: Keyfile and password are treated just
         # like 2 ways to input a passphrase, so we don't actually need to have
         # different contents of keyfile and passphrase, but it makes some
@@ -126,80 +264,100 @@ if $partition; then
         #    yes 'test' | cryptsetup luksRemoveKey /dev/... \
             #                            /key/file || [[ $? == 141 ]]
 
-        cryptsetup luksOpen $luks_dev crypt_dev_${luks_dev##/dev/} \
+        cryptsetup luksOpen `rootdev` `root-cryptname` \
                    --key-file $luks_dir/host-$HOSTNAME
     done
-    bpart ${crypt_devs[@]/%/$rootn}
-    mount $crypt /mnt
+    ls -la /dev/btrfs-control
+    sleep 1
+    bpart $(for dev in ${devs[@]}; do root-cryptdev; done)
+    bpart ${boot_devs[@]}
 else
     for dev in ${devs[@]}; do
-        cryptsetup luksOpen $dev$rootn crypt_dev_${dev##/dev/}$rootn \
-                   --key-file $luks_dir/host-$HOSTNAME || [[ $? == 141 ]]
+        cryptsetup luksOpen `rootdev` `root-cryptname` \
+                   --key-file $luks_dir/host-$HOSTNAME
     done
     sleep 1
-    mount -o subvolid=0 $crypt /mnt
-    # systemd creates subvolumes we want to delete.
-    s=($(btrfs subvolume list --sort=-path /mnt |
-                sed -rn 's#^.*path\s*(root/\S+)\s*$#\1#p'))
-    for subvol in ${s[@]}; do btrfs subvolume delete /mnt/$subvol; done
-    btrfs subvolume set-default 0 /mnt
-    btrfs subvolume delete /mnt/root
 fi
-bpart ${devs[@]/%/$bootn}
 
+mount -o subvolid=0 $first_root_crypt /mnt
+# systemd creates subvolumes we want to delete.
+s=($(btrfs subvolume list --sort=-path /mnt |
+         sed -rn "s#^.*path\s*(root_$DISTRO/\S+)\s*\$#\1#p"))
+for subvol in ${s[@]}; do btrfs subvolume delete /mnt/$subvol; done
+btrfs subvolume set-default 0 /mnt
+[[ ! -e /mnt/root_$DISTRO ]] || btrfs subvolume delete /mnt/root_$DISTRO
 
 ## create subvols ##
 cd /mnt
-for x in q home root; do
-    btrfs subvolume list . | grep "$x$" >/dev/null || btrfs subvolume create $x
-done
-for x in root/a q/a; do
+btrfs subvolume create root_$DISTRO
+[[ -e q ]] || btrfs subvolume create q
+chown root:1000 q
+
+mkdir -p /mnt/root_$DISTRO/boot
+for x in q/a q/i; do
     mkdir -p $x
     chown 1000:1000 $x
     chmod 755 $x
 done
-btrfs subvolume set-default \
-      $(btrfs subvolume list . | grep 'root$' | awk '{print $2}') .
-chattr -Rf +C root
+# could set default like this, but no reason to.
+# btrfs subvolume set-default \
+    #       $(btrfs subvolume list . | grep "root_$DISTRO$" | awk '{print $2}') .
+chattr -Rf +C root_$DISTRO
 cd /
 umount /mnt
-mount $first_boot_dev /mnt
+mount -o subvolid=0 $first_boot_dev /mnt
 cd /mnt
-btrfs subvolume create boot
-btrfs subvolume set-default \
-      $(btrfs subvolume list . | grep 'boot$' | awk '{print $2}') .
+btrfs subvolume set-default 0 /mnt
+[[ ! -e /mnt/boot_$DISTRO ]] || btrfs subvolume delete /mnt/boot_$DISTRO
+btrfs subvolume create boot_$DISTRO
 cd /
 umount /mnt
 ## end create subvols ##
 
 
-
+# note, the mount point /a seems to get automatically created somewhere
 cat > /tmp/fai/fstab <<EOF
-$crypt  /  btrfs  noatime,subvol=/root  0 0
-$crypt  /q  btrfs  noatime,subvol=/q  0 0
+$first_root_crypt  /  btrfs  noatime,subvol=root_$DISTRO  0 0
+$first_root_crypt  /q  btrfs  noatime,subvol=q  0 0
 /q/a  /a  none  bind  0 0
-$crypt  /home  btrfs  noatime,subvol=/home  0 0
-$first_boot_dev  /boot  btrfs  noatime,subvol=/boot  0 0
+$first_boot_dev  /boot  btrfs  noatime,subvol=boot_$DISTRO  0 0
 EOF
 
+
+if ifclass treetowl; then
+    cat >> /tmp/fai/fstab <<'EOF'
+UUID=3f7b31cd-f299-40b4-a86b-7604282e2715 /i btrfs  noatime  0 2
+EOF
+fi
+
+if ifclass frodo; then
+    cat >> /tmp/fai/fstab <<'EOF'
+/q/i  /i  none  bind  0 0
+EOF
+fi
+
 swaps=()
 for dev in ${devs[@]}; do
-    s=crypt_swap_${dev##/dev/}$swapn
-    swaps+=(/dev/mapper/$s)
+    swaps+=(`swap-cryptname`)
     cat >>/tmp/fai/crypttab <<EOF
-crypt_dev_${dev##/dev/}$rootn  $dev$rootn  none  keyscript=/root/keyscript,discard,luks
-$s $dev$swapn  /dev/urandom  swap,cipher=aes-xts-plain64,size=256,hash=ripemd160
+`root-cryptname`  `rootdev`  none  keyscript=/root/keyscript,discard,luks
+`swap-cryptname` `swapdev`  /dev/urandom  swap,cipher=aes-xts-plain64,size=256,hash=ripemd160
 EOF
     cat >> /tmp/fai/fstab <<EOF
-/dev/mapper/$s  none  swap  sw  0 0
+`swap-cryptdev`  none  swap  sw  0 0
 EOF
 done
 
+# fai would do this:
+#BOOT_DEVICE=\${BOOT_DEVICE:-"${devs[0]}"}
 
 # swaplist seems to do nothing.
+
 cat >/tmp/fai/disk_var.sh <<EOF
-ROOT_PARTITION=\${ROOT_PARTITION:-$crypt}
+# ROOT_PARTITIONS is added by me, used in arch setup.
+ROOT_PARTITIONS="${root_devs[@]}"
+ROOT_PARTITION=\${ROOT_PARTITION:-$first_root_crypt}
 BOOT_PARTITION=\${BOOT_PARTITION:-$first_boot_dev}
-BOOT_DEVICE=\${BOOT_DEVICE:-"${devs[0]}"}
+BOOT_DEVICE="${short_devs[@]}"
 SWAPLIST=\${SWAPLIST:-"${swaps[@]}"}
 EOF